// Generated by CoffeeScript 2.3.1
var indexOf = [].indexOf;

module.exports = function() {
  var DocPad, Errlop, cli, docpad, docpadUtil, extendr, instanceConfig, locale, result;
  // ---------------------------------
  // Are we the desired DocPad installation?

  // Prepare
  docpadUtil = require('./util');
  // Continue if we explcitly want to use the global installation
  if (indexOf.call(process.argv, '--global') >= 0) {
    // remove them to workaround https://github.com/cacjs/cac/issues/25
    process.argv = process.argv.filter(function(arg) {
      return arg !== '--global';
    });
  // continue

  // Continue if we are already the local installation
  } else if (docpadUtil.isLocalDocPadExecutable()) {

  // continue

  // Continue if the local installation doesn't exist
  } else if (docpadUtil.getLocalDocPadExecutableExistance() === false) {

  } else {
    // return
    // continue

    // Otherwise forward to the local installation
    return docpadUtil.startLocalDocPadExecutable();
  }
  // ---------------------------------
  // We are the desired DocPad installation

  // Prepare
  extendr = require('extendr');
  cli = require('cac')();
  locale = require('./locale/en');
  DocPad = require('./docpad');
  Errlop = require('errlop');
  docpad = null;
  instanceConfig = {};
  // Global options
  cli.option('outPath', {
    type: 'string',
    desc: locale.consoleOptionOutPath
  }).option('configPaths', {
    alias: ['configPath', 'config', 'c'],
    type: 'string',
    desc: locale.consoleOptionConfig
  }).option('environment', {
    alias: ['env', 'e'],
    type: 'string',
    desc: locale.consoleOptionEnv
  }).option('logLevel', {
    type: 'string',
    desc: locale.consoleOptionLogLevel
  }).option('verbose', {
    alias: ['v'],
    type: 'boolean',
    desc: locale.consoleOptionVerbose
  }).option('debug', {
    alias: ['d'],
    type: 'boolean',
    desc: locale.consoleOptionDebug
  }).option('global', {
    type: 'boolean',
    desc: locale.consoleOptionGlobal
  }).option('color', {
    alias: ['colour'],
    default: true,
    type: 'boolean',
    desc: locale.consoleOptionColor
  }).option('silent', {
    type: 'boolean',
    desc: locale.consoleOptionSilent
  }).option('progress', {
    default: true,
    type: 'boolean',
    desc: locale.consoleOptionProgress
  }).option('offline', {
    type: 'boolean',
    desc: locale.consoleOptionOffline
  });
  // Commands
  cli.command('run', {
    desc: locale.consoleDescriptionRun
  }, function(input, flags) {
    return docpad != null ? docpad.action('run', {
      skeleton: flags.skeleton
    }) : void 0;
  }).option('skeleton', {
    type: 'string',
    desc: locale.consoleOptionSkeleton
  });
  cli.command('init', {
    desc: locale.consoleDescriptionInit
  }, function(input, flags) {
    return docpad != null ? docpad.action('skeleton', {
      skeleton: flags.skeleton
    }) : void 0;
  }).option('skeleton', {
    type: 'string',
    desc: locale.consoleOptionSkeleton
  });
  cli.command('generate', {
    desc: locale.consoleDescriptionGenerate
  }, function(input, flags) {
    return docpad != null ? docpad.action('generate') : void 0;
  });
  cli.command('render', {
    desc: locale.consoleDescriptionRender,
    examples: ['docpad render <filename>', 'docpad render <filepath>', "echo '*example*' | docpad render"]
  }, function(input, flags) {
    var ref;
    instanceConfig.silent = true;
    return docpad != null ? docpad.action('render', {
      filename: input[0],
      renderSingleExtensions: 'auto',
      output: (ref = flags.output) != null ? ref : true,
      stdin: flags.stdin
    }) : void 0;
  }).option('output', {
    alias: ['out', 'o'],
    type: 'string',
    desc: locale.consoleOptionOutput
  }).option('stdin', {
    type: 'boolean',
    desc: locale.consoleOptionStdin
  });
  cli.command('watch', {
    desc: locale.consoleDescriptionWatch
  }, function(input, flags) {
    return docpad != null ? docpad.action('generate watch') : void 0;
  });
  cli.command('clean', {
    desc: locale.consoleDescriptionClean
  }, function(input, flags) {
    return docpad != null ? docpad.action('clean') : void 0;
  });
  cli.command('update', {
    desc: locale.consoleDescriptionUpdate
  }, function(input, flags) {
    return docpad != null ? docpad.action('clean update') : void 0;
  });
  cli.command('upgrade', {
    desc: locale.consoleDescriptionUpdate
  }, function(input, flags) {
    return docpad != null ? docpad.action('upgrade') : void 0;
  });
  cli.command('install', {
    desc: locale.consoleDescriptionInstall,
    examples: ['install <plugin>']
  }, function(input, flags) {
    return docpad != null ? docpad.action('install', {
      plugin: input[0]
    }) : void 0;
  });
  cli.command('uninstall', {
    desc: locale.consoleDescriptionUninstall,
    examples: ['uninstall <plugin>']
  }, function(input, flags) {
    return docpad != null ? docpad.action('uninstall', {
      plugin: input[0]
    }) : void 0;
  });
  cli.command('info', {
    desc: locale.consoleDescriptionInfo
  }, function(input, flags) {
    instanceConfig.silent = true;
    return docpad != null ? docpad.action('info') : void 0;
  });
  if (process.argv[2] === 'help') {
    // ---------------------------------
    // DocPad

    // Convert help command to --help
    process.argv[2] = '--help';
  }
  // Fetch options
  result = cli.parse();
  // Exit if we are help
  if (result.flags.help) {
    return;
  }
  // Otherwie, apply the configuration options to the instanceConfig
  Object.keys(DocPad.prototype.initialConfig).forEach(function(name) {
    var value;
    value = result.flags[name];
    if (value != null) {
      return instanceConfig[name] != null ? instanceConfig[name] : instanceConfig[name] = value;
    }
  });
  // Create
  return docpad = new DocPad(instanceConfig, function(err) {
    if (err) {
      return docpad.fatal(err);
    }
    // CLI
    return docpad.emitSerial('consoleSetup', {
      cac: cli
    }, function(err) {
      if (err) {
        return docpad.fatal(err);
      }
      // Help
      cli.command('*', {
        desc: locale.consoleDescriptionUnknown
      }, function(input, flags) {
        return cli.showHelp();
      });
      // Run the command
      return cli.parse();
    });
  });
};
